function V=CleanVR(V,M,level)

[rays,values,weights,matches]=LapBunny(level);

%tofix=[15:16,29:32,47:48,58:64];
%tofix=tofix(tofix<=2^(level-1));

if (level>=5) 
% Clean up the 15 16 pair
    eigfun15=M*V(:,15); % find full eigenfunctions
    eigfun16=M*V(:,16);
    c15=eigfun15(rays==(2^(level-1)-1*2^(level-5))); %pick constants
    c16=eigfun16(rays==(2^(level-1)-1*2^(level-5))); 
    
    V(:,16)=V(:,16)-c16*V(:,15)/c15; % cancel one circle
    
    eigfun16=M*V(:,16); % refind full eigenfunction
    c15=eigfun15(rays==(2^(level+1)+1*2^(level-5))); %find the new constants
    c16=eigfun16(rays==(2^(level+1)+1*2^(level-5)));
    
    V(:,15)=V(:,15)-c15*V(:,16)/c16; % cancel the other circle
    
    % Renormalize
    V(:,15)=V(:,15)/sqrt(sum(V(:,15).*V(:,15)));
    V(:,16)=V(:,16)/sqrt(sum(V(:,16).*V(:,16)));
    
    clear eigfun15 eigfun16 c15 c16
end
if(level>=6)
   % Isolate 1 circle
   eigfun29=M*V(:,29);
   eigfun30=M*V(:,30);
   eigfun31=M*V(:,31);
   eigfun32=M*V(:,32);
   
   c29=eigfun29(rays==(2^(level)+1*2^(level-6)));
   c30=eigfun30(rays==(2^(level)+1*2^(level-6)));
   c31=eigfun31(rays==(2^(level)+1*2^(level-6)));
   c32=eigfun32(rays==(2^(level)+1*2^(level-6)));
   
   V(:,30)=V(:,30)-c30*V(:,29)/c29;
   V(:,31)=V(:,31)-c31*V(:,29)/c29;
   V(:,32)=V(:,32)-c32*V(:,29)/c29;
   
  %Isolate 2nd 
  
   eigfun30=M*V(:,30);
   eigfun31=M*V(:,31);
   eigfun32=M*V(:,32);
   
   c29=eigfun29(rays==(22*2^(level-3)+1*2^(level-6)));
   c30=eigfun30(rays==(22*2^(level-3)+1*2^(level-6)));
   c31=eigfun31(rays==(22*2^(level-3)+1*2^(level-6)));
   c32=eigfun32(rays==(22*2^(level-3)+1*2^(level-6)));
   
   V(:,29)=V(:,29)-c29*V(:,30)/c30;
   V(:,31)=V(:,31)-c31*V(:,30)/c30;
   V(:,32)=V(:,32)-c32*V(:,30)/c30;
   
   %Isolate 3rd
  
   eigfun29=M*V(:,29);
   eigfun31=M*V(:,31);
   eigfun32=M*V(:,32);
   
   c29=eigfun29(rays==(9*2^(level-1)+1*2^(level-6)));
   c30=eigfun30(rays==(9*2^(level-1)+1*2^(level-6)));
   c31=eigfun31(rays==(9*2^(level-1)+1*2^(level-6)));
   c32=eigfun32(rays==(9*2^(level-1)+1*2^(level-6)));
   
   V(:,29)=V(:,29)-c29*V(:,31)/c31;
   V(:,30)=V(:,30)-c30*V(:,31)/c31;
   V(:,32)=V(:,32)-c32*V(:,31)/c31;
   
    %Isolate 4th
  
   eigfun29=M*V(:,29);
   eigfun30=M*V(:,30);
   eigfun32=M*V(:,32);
   
   c29=eigfun29(rays==(50*2^(level-3)+1*2^(level-6)));
   c30=eigfun30(rays==(50*2^(level-3)+1*2^(level-6)));
   c31=eigfun31(rays==(50*2^(level-3)+1*2^(level-6)));
   c32=eigfun32(rays==(50*2^(level-3)+1*2^(level-6)));
   
   V(:,29)=V(:,29)-c29*V(:,32)/c32;
   V(:,30)=V(:,30)-c30*V(:,32)/c32;
   V(:,31)=V(:,31)-c31*V(:,32)/c32;
   
   % Renormalize
    V(:,29)=V(:,29)/sqrt(sum(V(:,29).*V(:,29)));
    V(:,30)=V(:,30)/sqrt(sum(V(:,30).*V(:,30)));
    V(:,31)=V(:,31)/sqrt(sum(V(:,31).*V(:,31)));
   
   clear eigfun29 eigfun30 eignfun31 eigfun32 c29 c30 c31 c32
end
if(level>=7)
    eigfun47=M*V(:,47); % find full eigenfunctions
    eigfun48=M*V(:,48);
    c47=eigfun47(rays==(2^(level-1)-4*2^(level-7))); %pick constants
    c48=eigfun48(rays==(2^(level-1)-4*2^(level-7))); 
    
    V(:,48)=V(:,48)-c48*V(:,47)/c47; % cancel one circle
    
    eigfun48=M*V(:,48); % find full eigenfunction
    c47=eigfun47(rays==(2^(level+1)+4*2^(level-7))); %find the new constants
    c48=eigfun48(rays==(2^(level+1)+4*2^(level-7)));
    V(:,47)=V(:,47)-c47*V(:,48)/c48; % cancel the other circle
    
    % Renormalize
    V(:,47)=V(:,47)/sqrt(sum(V(:,47).*V(:,47)));
    V(:,48)=V(:,29)/sqrt(sum(V(:,48).*V(:,48)));
     
    clear eigfun47 eigfun48 c47 c48
    
    % Eliminate Center Circle
    eigfun58=M*V(:,58);
    eigfun59=M*V(:,59);
    eigfun60=M*V(:,60);
    eigfun61=M*V(:,61);
    eigfun62=M*V(:,62);
    eigfun63=M*V(:,63);
    eigfun64=M*V(:,64);
    
    c58=eigfun58(rays==2^(level-1)+1*2^(level-7));
    c59=eigfun59(rays==2^(level-1)+1*2^(level-7));
    c60=eigfun60(rays==2^(level-1)+1*2^(level-7));
    c61=eigfun61(rays==2^(level-1)+1*2^(level-7));
    c62=eigfun62(rays==2^(level-1)+1*2^(level-7));
    c63=eigfun63(rays==2^(level-1)+1*2^(level-7));
    c64=eigfun64(rays==2^(level-1)+1*2^(level-7));
    
    V(:,59)=V(:,59)-c59*V(:,58)/c58;
    V(:,60)=V(:,60)-c60*V(:,58)/c58;
    V(:,61)=V(:,61)-c61*V(:,58)/c58;
    V(:,62)=V(:,62)-c62*V(:,58)/c58;
    V(:,63)=V(:,63)-c63*V(:,58)/c58;
    V(:,64)=V(:,64)-c64*V(:,58)/c58;
    
    % Eliminate Exterior Circles 
    eigfun58=M*V(:,58);
    eigfun59=M*V(:,59);
    eigfun60=M*V(:,60);
    eigfun61=M*V(:,61);
    eigfun62=M*V(:,62);
    eigfun63=M*V(:,63);
    eigfun64=M*V(:,64);
    
    c58=eigfun58(rays==9*2^(level-7));
    c59=eigfun59(rays==9*2^(level-7));
    c60=eigfun60(rays==9*2^(level-7));
    c61=eigfun61(rays==9*2^(level-7));
    c62=eigfun62(rays==9*2^(level-7));
    c63=eigfun63(rays==9*2^(level-7));
    c64=eigfun64(rays==9*2^(level-7));
    
    V(:,58)=V(:,58)-c58*V(:,59)/c59;
    V(:,60)=V(:,60)-c60*V(:,59)/c59;
    V(:,61)=V(:,61)-c61*V(:,59)/c59;
    V(:,62)=V(:,62)-c62*V(:,59)/c59;
    V(:,63)=V(:,63)-c63*V(:,59)/c59;
    V(:,64)=V(:,64)-c64*V(:,59)/c59;
    
    %2nd
    eigfun58=M*V(:,58);
    eigfun59=M*V(:,59);
    eigfun60=M*V(:,60);
    eigfun61=M*V(:,61);
    eigfun62=M*V(:,62);
    eigfun63=M*V(:,63);
    eigfun64=M*V(:,64);
    
    c58=eigfun58(rays==177*2^(level-7));
    c59=eigfun59(rays==177*2^(level-7));
    c60=eigfun60(rays==177*2^(level-7));
    c61=eigfun61(rays==177*2^(level-7));
    c62=eigfun62(rays==177*2^(level-7));
    c63=eigfun63(rays==177*2^(level-7));
    c64=eigfun64(rays==177*2^(level-7));
    
    V(:,58)=V(:,58)-c58*V(:,60)/c60;
    V(:,59)=V(:,59)-c59*V(:,60)/c60;
    V(:,61)=V(:,61)-c61*V(:,60)/c60;
    V(:,62)=V(:,62)-c62*V(:,60)/c60;
    V(:,63)=V(:,63)-c63*V(:,60)/c60;
    V(:,64)=V(:,64)-c64*V(:,60)/c60;
    
    %3rd
    eigfun58=M*V(:,58);
    eigfun59=M*V(:,59);
    eigfun60=M*V(:,60);
    eigfun61=M*V(:,61);
    eigfun62=M*V(:,62);
    eigfun63=M*V(:,63);
    eigfun64=M*V(:,64);
    
    c58=eigfun58(rays==289*2^(level-7));
    c59=eigfun59(rays==289*2^(level-7));
    c60=eigfun60(rays==289*2^(level-7));
    c61=eigfun61(rays==289*2^(level-7));
    c62=eigfun62(rays==289*2^(level-7));
    c63=eigfun63(rays==289*2^(level-7));
    c64=eigfun64(rays==289*2^(level-7));
    
    V(:,58)=V(:,58)-c58*V(:,61)/c61;
    V(:,59)=V(:,59)-c59*V(:,61)/c61;
    V(:,60)=V(:,60)-c60*V(:,61)/c61;
    V(:,62)=V(:,62)-c62*V(:,61)/c61;
    V(:,63)=V(:,63)-c63*V(:,61)/c61;
    V(:,64)=V(:,64)-c64*V(:,61)/c61;
    
    %4th
    eigfun58=M*V(:,58);
    eigfun59=M*V(:,59);
    eigfun60=M*V(:,60);
    eigfun61=M*V(:,61);
    eigfun62=M*V(:,62);
    eigfun63=M*V(:,63);
    eigfun64=M*V(:,64);
    
    c58=eigfun58(rays==401*2^(level-7));
    c59=eigfun59(rays==401*2^(level-7));
    c60=eigfun60(rays==401*2^(level-7));
    c61=eigfun61(rays==401*2^(level-7));
    c62=eigfun62(rays==401*2^(level-7));
    c63=eigfun63(rays==401*2^(level-7));
    c64=eigfun64(rays==401*2^(level-7));
    
    V(:,58)=V(:,58)-c58*V(:,62)/c62;
    V(:,59)=V(:,59)-c59*V(:,62)/c62;
    V(:,60)=V(:,60)-c60*V(:,62)/c62;
    V(:,61)=V(:,61)-c61*V(:,62)/c62;
    V(:,63)=V(:,63)-c63*V(:,62)/c62;
    V(:,64)=V(:,64)-c64*V(:,62)/c62;
    
    %5th
    eigfun58=M*V(:,58);
    eigfun59=M*V(:,59);
    eigfun60=M*V(:,60);
    eigfun61=M*V(:,61);
    eigfun62=M*V(:,62);
    eigfun63=M*V(:,63);
    eigfun64=M*V(:,64);
    
    c58=eigfun58(rays==625*2^(level-7));
    c59=eigfun59(rays==625*2^(level-7));
    c60=eigfun60(rays==625*2^(level-7));
    c61=eigfun61(rays==625*2^(level-7));
    c62=eigfun62(rays==625*2^(level-7));
    c63=eigfun63(rays==625*2^(level-7));
    c64=eigfun64(rays==625*2^(level-7));
    
    V(:,58)=V(:,58)-c58*V(:,63)/c63;
    V(:,59)=V(:,59)-c59*V(:,63)/c63;
    V(:,60)=V(:,60)-c60*V(:,63)/c63;
    V(:,61)=V(:,61)-c61*V(:,63)/c63;
    V(:,62)=V(:,62)-c62*V(:,63)/c63;
    V(:,64)=V(:,64)-c64*V(:,63)/c63;
    
    %6th
    eigfun58=M*V(:,58);
    eigfun59=M*V(:,59);
    eigfun60=M*V(:,60);
    eigfun61=M*V(:,61);
    eigfun62=M*V(:,62);
    eigfun63=M*V(:,63);
    eigfun64=M*V(:,64);
    
    c58=eigfun58(rays==737*2^(level-7));
    c59=eigfun59(rays==737*2^(level-7));
    c60=eigfun60(rays==737*2^(level-7));
    c61=eigfun61(rays==737*2^(level-7));
    c62=eigfun62(rays==737*2^(level-7));
    c63=eigfun63(rays==737*2^(level-7));
    c64=eigfun64(rays==737*2^(level-7));
    
    V(:,58)=V(:,58)-c58*V(:,64)/c64;
    V(:,59)=V(:,59)-c59*V(:,64)/c64;
    V(:,60)=V(:,60)-c60*V(:,64)/c64;
    V(:,61)=V(:,61)-c61*V(:,64)/c64;
    V(:,62)=V(:,62)-c62*V(:,64)/c64;
    V(:,63)=V(:,63)-c63*V(:,64)/c64;
    
    % Renormalize
    V(:,58)=V(:,58)/sqrt(sum(V(:,58).*V(:,58)));
    V(:,59)=V(:,59)/sqrt(sum(V(:,59).*V(:,59)));
    V(:,60)=V(:,60)/sqrt(sum(V(:,60).*V(:,60)));
    V(:,61)=V(:,61)/sqrt(sum(V(:,61).*V(:,61)));
    V(:,62)=V(:,62)/sqrt(sum(V(:,62).*V(:,62)));
    V(:,63)=V(:,63)/sqrt(sum(V(:,63).*V(:,63)));
    V(:,64)=V(:,64)/sqrt(sum(V(:,64).*V(:,64)));
end
    

