% function incirc=InCircle(level)
% ----------------------------------------
% Finds the total sum of the weights in the inner circle of the
% bascilica for the conformal measure for iterations 2 through level
% allows us to the behavoir. 

function [incirc,incircp] = InCircleR(level)

[rays,values,weights,matches]=LapBunny(level,'n');

% We want points with ray angles 1/14<a<9/14 
% and also points that don't occur btw matched points so...

% denom value is 7*2^level
incirc=rays>=2^(level-1)&rays<=9*2^(level-1)|rays==11*2^(level-1);
 
% Thin matches 
cutoffs=rays(matches);	% Lower ray first
for i=1:length(cutoffs(:,1))    % eliminate pairs less than 1/14
        if cutoffs(i,1)<=2^(level-1)||cutoffs(i,1)>=9*2^(level-1)
            cutoffs(i,:)=[0,0,0];
        end
end
    
 cutoffs=[cutoffs(cutoffs(:,1)>0,1),cutoffs(cutoffs(:,2)>0,2),cutoffs(cutoffs(:,3)>0,3)]; %eliminate dead rows
    
 [nr,nc]=size(cutoffs);
    
 for i=1:nr 
        hi=cutoffs-[cutoffs(i,1).*ones(nr,1),cutoffs(i,2).*ones(nr,1),cutoffs(i,3).*ones(nr,1)];
        good=sign(hi(:,1))==sign(hi(:,2))& sign(hi(:,3))==sign(hi(:,2));
        good=[good,good,good];
        cutoffs=cutoffs.*good;
 end
    cutoffs=[cutoffs(cutoffs(:,1)>0,1),cutoffs(cutoffs(:,2)>0,2),cutoffs(cutoffs(:,3)>0,3)]; %eliminate dead rows
    
 [nr,nc]=size(cutoffs);
 incircp=zeros(1,length(rays));
 for i=1:nr  
       % remove points between matches
       incirc=incirc.*(~(rays>cutoffs(i,1)&rays<cutoffs(i,3))); 
       incircp=incircp+(rays==cutoffs(i,1));
       % add back in the third of the pair
       incirc=incirc+(rays==cutoffs(i,2));
 end 
 
 incircp=incircp+(rays==11*2^(level-1))+(rays==2^(level-1));
 %add back matches of removed points

 incircp=logical(incircp);
 incirc=logical(incirc);
% plot3(real(values(incirc)),imag(values(incirc)),rays(incirc));
 
    
        
  
